// TestRichEditCtrl.cpp : implementation file
// Author: Ovidiu Cucu
// Homepage: http://www.codexpert.ro/

#include "stdafx.h"
#include "richeditbartest.h"
#include "TestRichEditCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

 

/////////////////////////////////////////////////////////////////////////////
// CTestRichEditCtrl


CTestRichEditCtrl::CTestRichEditCtrl()
{

}

CTestRichEditCtrl::~CTestRichEditCtrl()
{
}


BEGIN_MESSAGE_MAP(CTestRichEditCtrl, CRichEditCtrl)
	//{{AFX_MSG_MAP(CTestRichEditCtrl)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestRichEditCtrl message handlers

void CTestRichEditCtrl::PreSubclassWindow() 
{
   VERIFY(SetOLECallback(&m_xRichEditOleCallback));
}




/////////////////////////////////////////////////////////////////////////////
// CTestRichEditCtrl::XRichEditOleCallback

BEGIN_INTERFACE_MAP(CTestRichEditCtrl, CRichEditCtrl)
	// we use IID_IUnknown because richedit doesn't define an IID
	INTERFACE_PART(CTestRichEditCtrl, IID_IUnknown, RichEditOleCallback)
END_INTERFACE_MAP()

STDMETHODIMP_(ULONG) CTestRichEditCtrl::XRichEditOleCallback::AddRef()
{
	METHOD_PROLOGUE_EX_(CTestRichEditCtrl, RichEditOleCallback)
	return (ULONG)pThis->InternalAddRef();
}

STDMETHODIMP_(ULONG) CTestRichEditCtrl::XRichEditOleCallback::Release()
{
	METHOD_PROLOGUE_EX_(CTestRichEditCtrl, RichEditOleCallback)
	return (ULONG)pThis->InternalRelease();
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::QueryInterface(
	REFIID iid, LPVOID* ppvObj)
{
	METHOD_PROLOGUE_EX_(CTestRichEditCtrl, RichEditOleCallback)
	return (HRESULT)pThis->InternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::GetNewStorage(LPSTORAGE* ppstg)
{
	METHOD_PROLOGUE_EX_(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::GetInPlaceContext(
	LPOLEINPLACEFRAME* lplpFrame, LPOLEINPLACEUIWINDOW* lplpDoc,
	LPOLEINPLACEFRAMEINFO lpFrameInfo)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::ShowContainerUI(BOOL fShow)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::QueryInsertObject(
	LPCLSID /*lpclsid*/, LPSTORAGE /*pstg*/, LONG /*cp*/)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::DeleteObject(LPOLEOBJECT /*lpoleobj*/)
{
	METHOD_PROLOGUE_EX_(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::QueryAcceptData(
	LPDATAOBJECT lpdataobj, CLIPFORMAT* lpcfFormat, DWORD reco,
	BOOL fReally, HGLOBAL hMetaPict)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::ContextSensitiveHelp(BOOL /*fEnterMode*/)
{
   METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
	return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::GetClipboardData(
	CHARRANGE* lpchrg, DWORD reco, LPDATAOBJECT* lplpdataobj)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::GetDragDropEffect(
	BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect)
{
   METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
	return E_NOTIMPL;
}

STDMETHODIMP CTestRichEditCtrl::XRichEditOleCallback::GetContextMenu(
	WORD seltype, LPOLEOBJECT lpoleobj, CHARRANGE* lpchrg,
	HMENU* lphmenu)
{
	METHOD_PROLOGUE_EX(CTestRichEditCtrl, RichEditOleCallback)
   TRACE0("CTestRichEditCtrl::XRichEditOleCallback::GetContextMenu\n");

   // NOTE: This is just for demo purpose.
   //       You may have to improve it by providing different menus
   //       according to selection type, OLE object pointer, character range and/or other criteria.
   HINSTANCE hInstance = AfxGetInstanceHandle();
   HMENU hMenu = ::LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));
   *lphmenu = ::GetSubMenu(hMenu, 1);

   return S_OK;
}
